ETSI STF525 / Internal Testing test suite This project provides an internal testing test suite and its associated Test Adapter/Codec

Public Member Functions | Protected Attributes | List of all members
security_cache Class Reference

This class provides security record description for in memory security database. In memory mens there is no disk load/save mechanism. More...

`#include <security_cache.hh>`

Inheritance diagram for security_cache:

## Public Member Functions
| security_cache ()
| List of the certificates indexed by the HashedId8. More...
virtual | ~security_cache ()
| Default private dtor. More...
int | get_certificate_id (const OCTETSTRING &p_hashed_id8, std::string &p_certificate_id) const
int | get_certificate (const std::string &p_certificate_id, OCTETSTRING &p_certificate) const
int | get_certificate (const std::string &p_certificate_id, IEEE1609dot2::CertificateBase &p_certificate) const
int | get_issuer (const std::string &p_certificate_id, OCTETSTRING &p_hashed_id_issuer) const
int | get_hashed_id (const std::string &p_certificate_id, OCTETSTRING &p_hashed_id) const
int | get_private_key (const std::string &p_certificate_id, OCTETSTRING &p_private_key) const
int | get_public_keys (const std::string &p_certificate_id, OCTETSTRING &p_public_key_x, OCTETSTRING &p_public_key_y) const
int | get_private_enc_key (const std::string &p_certificate_id, OCTETSTRING &p_private_enc_key) const
int | get_public_enc_keys (const std::string &p_certificate_id, OCTETSTRING &p_public_enc_key_x, OCTETSTRING &p_public_enc_key_y) const
virtual int | store_certificate (const CHARSTRING &p_cert_id, const OCTETSTRING &p_cert, const OCTETSTRING &p_private_key, const OCTETSTRING &p_public_key_x, const OCTETSTRING &p_public_key_y, const OCTETSTRING &p_hashid8, const OCTETSTRING &p_issuer, const OCTETSTRING &p_private_enc_key, const OCTETSTRING &p_public_enc_key_x, const OCTETSTRING &p_public_enc_key_y)
virtual int | clear ()
void | dump () const

## Protected Attributes
std::map< std::string, std::unique_ptr< security_db_record > > | _certificates
std::map< std::vector< unsigned char >, std::string > | _hashed_id8s
| List of the certificates indexed by the certificate identifier. More...

## Detailed Description

This class provides security record description for in memory security database. In memory mens there is no disk load/save mechanism.

## Constructor & Destructor Documentation

## ◆ security_cache()

security_cache::security_cache | ( |  | ) |

List of the certificates indexed by the HashedId8.

Default ctor

## ◆ ~security_cache()

security_cache::~security_cache | ( |  | ) |
| virtual

Default private dtor.

## Member Function Documentation

## ◆ clear()

int security_cache::clear | ( |  | ) |
| virtual

Reimplemented in security_db.

## ◆ dump()

void security_cache::dump | ( |  | ) | const

## ◆ get_certificate() [1/2]

int security_cache::get_certificate | ( | const std::string & | p_certificate_id,
|  | OCTETSTRING & | p_certificate
| ) |  | const

## ◆ get_certificate() [2/2]

int security_cache::get_certificate | ( | const std::string & | p_certificate_id,
|  | IEEE1609dot2::CertificateBase & | p_certificate
| ) |  | const

## ◆ get_certificate_id()

int security_cache::get_certificate_id | ( | const OCTETSTRING & | p_hashed_id8,
|  | std::string & | p_certificate_id
| ) |  | const

## ◆ get_hashed_id()

int security_cache::get_hashed_id | ( | const std::string & | p_certificate_id,
|  | OCTETSTRING & | p_hashed_id
| ) |  | const

## ◆ get_issuer()

int security_cache::get_issuer | ( | const std::string & | p_certificate_id,
|  | OCTETSTRING & | p_hashed_id_issuer
| ) |  | const

## ◆ get_private_enc_key()

int security_cache::get_private_enc_key | ( | const std::string & | p_certificate_id,
|  | OCTETSTRING & | p_private_enc_key
| ) |  | const

## ◆ get_private_key()

int security_cache::get_private_key | ( | const std::string & | p_certificate_id,
|  | OCTETSTRING & | p_private_key
| ) |  | const

## ◆ get_public_enc_keys()

int security_cache::get_public_enc_keys | ( | const std::string & | p_certificate_id,
|  | OCTETSTRING & | p_public_enc_key_x,
|  | OCTETSTRING & | p_public_enc_key_y
| ) |  | const

## ◆ get_public_keys()

int security_cache::get_public_keys | ( | const std::string & | p_certificate_id,
|  | OCTETSTRING & | p_public_key_x,
|  | OCTETSTRING & | p_public_key_y
| ) |  | const

## ◆ store_certificate()

int security_cache::store_certificate | ( | const CHARSTRING & | p_cert_id,
|  | const OCTETSTRING & | p_cert,
|  | const OCTETSTRING & | p_private_key,
|  | const OCTETSTRING & | p_public_key_x,
|  | const OCTETSTRING & | p_public_key_y,
|  | const OCTETSTRING & | p_hashid8,
|  | const OCTETSTRING & | p_issuer,
|  | const OCTETSTRING & | p_private_enc_key,
|  | const OCTETSTRING & | p_public_enc_key_x,
|  | const OCTETSTRING & | p_public_enc_key_y
| ) |  |
| virtual

Reimplemented in security_db.

## Member Data Documentation

## ◆ _certificates

std::map<std::string, std::unique_ptr<security_db_record> > security_cache::_certificates
| protected

## ◆ _hashed_id8s

std::map<std::vector<unsigned char>, std::string> security_cache::_hashed_id8s
| protected

List of the certificates indexed by the certificate identifier.

The documentation for this class was generated from the following files:

- /home/vagrant/TriesAndDelete/etsi_its/framework/include/security_cache.hh
- /home/vagrant/TriesAndDelete/etsi_its/framework/src/security_cache.cc